var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Executing MAXScript from Python</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Executing MAXScript from Python</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"executing-maxscript-from-python\"></a></div>\n\
<div class=\'section\'><a id=\"executing-maxscript-from-python-1\"></a><h2 id=\"executing-maxscript-from-python-1\">Executing MAXScript from Python</h2></div>\n\
<p>There are two Python modules that expose MAXScript to Python: <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MaxPlus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_max_plus.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus</a></span> and <span class=\'code\'>pymxs</span>. <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MaxPlus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_max_plus.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus</a></span> is based on the Max C++ SDK, and contains utility functions like <span class=\'code\'>EvalMAXScript()</span>, while <span class=\'code\'>pymxs.runtime</span> is a wrapper for the MAXScript engine, and exposes virtually all the Interfaces, globals, and classes available in MAXScript.</p>\n\
<p>For more information about the pymxs API, see <a href=\"#!/url=./developer/pymxs_api_introduction.html\">pymxs API Introduction</a>.</p>\n\
<div class=\'section\'><a id=\"executing-maxscript-code-from-python-with-maxplus\"></a><h2 id=\"executing-maxscript-code-from-python-with-maxplus\">Executing MAXScript code from Python with MaxPlus</h2></div>\n\
<p>You can execute MAXScript code from Python using the <span class=\'code\'>Core.EvalMAXScript</span> method.</p>\n\
<p>The following command in Python executes the MAXScript code to print <span class=\'code\'>\\#aaa</span> to the MAXScript Listener window:</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Core.EvalMAXScript\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a00c76297f347dd3d50c629827c7217a1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Core.EvalMAXScript</a>(&quot;print #aaa&quot;)\n\
</pre></div><p>The following command in MAXScript executes Python, which executes the MAXScript code:</p>\n\
<div class=\'codeBlock\'><pre>commandString1 = \n\
&quot;import MaxPlus\n\
<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Core.EvalMAXScript\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a00c76297f347dd3d50c629827c7217a1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Core.EvalMAXScript</a>(\\&quot;print #aaa\\&quot;)\n\
&quot;\n\
python.execute commandString1\n\
</pre></div><div class=\'section\'><a id=\"fpvalues-returned-when-executing-maxscript-code-from-python\"></a><h2 id=\"fpvalues-returned-when-executing-maxscript-code-from-python\">FPValues returned when executing MAXScript code from Python</h2></div>\n\
<p>An <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span> is a single value that is returned when a MAXScript expression is evaluated. An <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span> wraps various types of values, for example, int, float, object, mesh, and so forth.</p>\n\
<p>You can execute a MAXScript expression using <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Core.EvalMAXScript()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a00c76297f347dd3d50c629827c7217a1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Core.EvalMAXScript()</a></span> and obtain a return value via <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span> using either:</p>\n\
<div class=\'codeBlock\'><pre>&lt;FPValue&gt; = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Core.EvalMAXScript\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a00c76297f347dd3d50c629827c7217a1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Core.EvalMAXScript</a>(&lt;string&gt;)\n\
</pre></div><p>or:</p>\n\
<div class=\'codeBlock\'><pre>res = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.FPValue</a>()\n\
evaluation_success = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Core.EvalMAXScript\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a00c76297f347dd3d50c629827c7217a1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Core.EvalMAXScript</a>(&lt;string&gt;, res)\n\
</pre></div><p>If an error occurs while running the MAXScript expression when using the first method signature above, a runtime exception is thrown. When using the second method signature, a value of <span class=\'code\'>False</span> is returned and the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span> contains a <span class=\'code\'>String</span> value with the error message.</p>\n\
<p>Use <span class=\'code\'>FPValue.Get()</span> to obtain the value stored in the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span>. This method returns the appropriate Python value type based on the type of value stored in the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span>. The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPTypeConstants\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_type_constants.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPTypeConstants</a></span> class contains a list of the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span> types. The <span class=\'code\'>FPTypeGetName(&lt;int&gt;)</span> method returns a string corresponding to the supplied type value.</p>\n\
<p>If you run the following:</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
help(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.FPTypeConstants\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_type_constants.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.FPTypeConstants</a>)\n\
</pre></div><p>You obtain, in the MAXScript Listener, a list of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span> <span class=\'code\'>type</span> names and their corresponding constants:</p>\n\
<ul>\n\
<li>AngAxis = 27</li>\n\
<li>AngAxisTab = 2075</li>\n\
<li>Angle = 5</li>\n\
<li>AngleTab = 2053</li>\n\
<li>BOOL = 4, and so forth</li>\n\
</ul>\n\
<p>There are some values that can be returned by a MAXScript expression that are not convertible to a value type supported by <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span>. In this case, the actual MAXScript value is returned in the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span>. There is currently no Python wrapper class for MAXScript values, so calling <span class=\'code\'>Get()</span> on such an <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span> results in a runtime error <em>&#39;unable to find an appropriate get function for type 44&#39;</em>. The <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span> type corresponding to MAXScript values is 44 (<span class=\'code\'>FPTypeConstants.Value</span>).</p>\n\
<p>In the following example, <span class=\'code\'>Core.EvalMAXScript(&#39;$&#39;+node.Name)</span> returns a <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FPValue</a></span>, the type of which we obtain via <span class=\'code\'>FPValue.GetType()</span>, the type as string we obtain via <span class=\'code\'>FPTypeGetName(r.GetType())</span>, and the value of which we obtain via <span class=\'code\'>FPValue.Get()</span>.</p>\n\
<div class=\'codeBlock\'><pre>&#39;&#39;&#39;\n\
    Demonstrates evaluating a MAXScript expression and getting a node value from it.\n\
&#39;&#39;&#39;\n\
import MaxPlus \n\
obj = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateGeomObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a3d630028591390310699de24f0a6a658&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Factory.CreateGeomObject</a>(MaxPlus.ClassIds.Cone) \n\
obj.ParameterBlock.radius1.Value = 5.0\n\
obj.ParameterBlock.radius2.Value = 10.0\n\
node = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a5db9618585b8541c4f22a66190a3056f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Factory.CreateNode</a>(obj) \n\
node.Name = &#39;PythonCone001&#39; \n\
r = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Core.EvalMAXScript\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a00c76297f347dd3d50c629827c7217a1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Core.EvalMAXScript</a>(&#39;$&#39;+node.Name) \n\
print r.GetType(), MaxPlus.FPTypeGetName(r.GetType()), r.Get()\n\
</pre></div><div class=\'section\'><a id=\"getting-the-base-type-for-an-fpvalue-type\"></a><h2 id=\"getting-the-base-type-for-an-fpvalue-type\">Getting the base type for an FPValue type</h2></div>\n\
<p>For each type, there is a corresponding tab type. For example, there is an <span class=\'code\'>Int</span> type, and an <span class=\'code\'>IntTab</span> type. <span class=\'code\'>IntTab</span> is similar to a tab (or an array) of integer values. The type value for a Tab type is the type value for the base type plus bit 0x0800 (held in variable TYPE_TAB below) being set.</p>\n\
<p>The following code demonstrates how to print the base type for a type by using ~TYPE_TAB.</p>\n\
<p><span class=\'code\'>MaxPlus.FPTypeConstants.IntTab &amp; ~TYPE_TAB</span> prints out the bits <em>other than</em> TYPE_TAB that are set and therefore prints out the base type for <span class=\'code\'>Int</span>/<span class=\'code\'>IntTab</span>.</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
TYPE_TAB = 0x0800 \n\
print (MaxPlus.FPTypeConstants.Int)  #prints 1\n\
print (MaxPlus.FPTypeConstants.IntTab)  #prints 2049\n\
print (MaxPlus.FPTypeConstants.IntTab &amp; ~TYPE_TAB)  #prints 1, which is the base type for the IntTab type\n\
</pre></div><div class=\'section\'><a id=\"fpvalues-and-python-equivalence\"></a><h2 id=\"fpvalues-and-python-equivalence\">FPValues And Python Equivalence</h2></div>\n\
<p>FPValues are wrappers for 3ds Max objects, so they are unique even if they point to the same object. For this reason, two FPValues pointing at the same node are considered equal (<span class=\'code\'>==</span>) but not identical (&quot;<span class=\'code\'>is</span>&quot;) in Python. This also applies to non-equivalence, <span class=\'code\'>!=</span> and &quot;<span class=\'code\'>is not</span>&quot; comparisons. The example below illustrates this difference.</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
# create a sphere node\n\
node_name = &quot;my_sphere&quot;\n\
obj = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateGeomObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a3d630028591390310699de24f0a6a658&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Factory.CreateGeomObject</a>(MaxPlus.ClassIds.Sphere)\n\
node = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a5db9618585b8541c4f22a66190a3056f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Factory.CreateNode</a>(obj, node_name)\n\
result = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.FPValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_f_p_value.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.FPValue</a>()\n\
# get one FPValue pointer to the object by running some MAXScript\n\
evaluation_success = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Core.EvalMAXScript\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a00c76297f347dd3d50c629827c7217a1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Core.EvalMAXScript</a>(&#39;$%s&#39; % node_name, result)\n\
handle1 =  result.Get()\n\
# get a second pointer to the same object\n\
evaluation_success = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Core.EvalMAXScript\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a00c76297f347dd3d50c629827c7217a1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Core.EvalMAXScript</a>(&#39;$%s&#39; % node_name, result)\n\
handle2 = result.Get()\n\
\n\
# this prints True:\n\
print &#39;Objects are equal: %s&#39; % (handle1 == handle2)\n\
# this prints False:\n\
print &#39;Objects are not equal: %s&#39; % (handle1 != handle2)\n\
# this prints False:\n\
print &#39;Objects are identical: %s&#39; % (handle1 is handle2)\n\
# this prints True:\n\
print &#39;Objects are not identical: %s&#39; % (handle1 is not handle2)\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>Note:</strong> For more information regarding MAXScript, see the MAXScript Documentation at <a href=\'http://www.autodesk.com/me-sdk-docs\' title=\'\' target=\'_blank\'>http://www.autodesk.com/me-sdk-docs</a>.</p>\n\
\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";