var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>MaxPlus Python API Introduction</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>MaxPlus Python API Introduction</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"maxplus-python-api-introduction\"></a></div>\n\
<p>This is an introductory &quot;How to&quot; section for the 3ds Max MaxPlus Python API.</p>\n\
<p>The 3ds Max MaxPlus Python API is built on top of and based on the 3ds Max C++ SDK. Global functions, and functions from static interfaces such as the <span class=\'code\'>Interface</span> class and the derived classes (<span class=\'code\'>Interface7</span> and so forth), have been regrouped into smaller classes based on functionality, such as: <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"RenderSettings\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_render_settings.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">RenderSettings</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Animation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_animation.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Animation</a></span>, <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Grid\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_grid.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Grid</a></span>, or <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Snaps\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_snaps.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Snaps</a></span>. Refactoring was performed for several functionalities in global functions, as well as the core interfaces into the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"INode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_i_node.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">INode</a></span> class. The goal was to create an API that is more intuitive.</p>\n\
<div class=\'section\'><a id=\"use-help-and-dir\"></a><h2 id=\"use-help-and-dir\">Use help and dir</h2></div>\n\
<p><span class=\'code\'>help()</span> and <span class=\'code\'>dir()</span> are two of the most useful functions in Python.</p>\n\
<p>For example, you can obtain a list of attributes for a class (list of methods, variables) using <span class=\'code\'>help</span> as follows:</p>\n\
<div class=\'codeBlock\'><pre>import MaxPlus\n\
help(<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Asset\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_asset.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Asset</a>)\n\
</pre></div><p>In your MAXScript Listener window, you will obtain a list of all attributes for the <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Asset\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_asset.html&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Asset</a></span> class. To obtain a list of attributes for an object, you can also use the Python built-in <span class=\'code\'>dir()</span> function. The <span class=\'code\'>dir(object)</span> function, when passed an argument (object), returns a list of attributes for the object.</p>\n\
<p>For more information regarding these two functions, as well as other tips and tricks, see <a href=\"#!/url=./developer/tips_and_tricks_for_3ds_max_pyth.html\">Tips and tricks for 3ds Max Python scripting</a>.</p>\n\
<div class=\'section\'><a id=\"printing-in-your-script\"></a><h2 id=\"printing-in-your-script\">Printing in your script</h2></div>\n\
<p>In the 3ds Max environment, data sent from a Python script to <span class=\'code\'>sys.stdout</span> (for example, by using <span class=\'code\'>print</span>) or to <span class=\'code\'>sys.stderr</span> is redirected to the MAXScript Listener window.</p>\n\
<p>Note that 3ds Max is not thread-safe, so printing to the Listener Window from threads other than the main thread can cause the application to crash, and is not recommended. If you are using multiple threads in your script, you can disconnect <span class=\'code\'>sys.stdout</span> and <span class=\'code\'>sys.stderr</span> from the Listener using these commands at the beginning of your script:</p>\n\
<div class=\'codeBlock\'><pre>sys.stdout = _old_stdout\n\
sys.stderr = _old_stderr\n\
</pre></div><div class=\'section\'><a id=\"about-properties\"></a><h2 id=\"about-properties\">About properties</h2></div>\n\
<p>A property is an attribute that is the equivalent of a <span class=\'code\'>Get()</span> and <span class=\'code\'>Set()</span>method pair. You can simply access the attribute to query or set its value.</p>\n\
<p>There exist also read-only properties, which are the equivalent of their corresponding <span class=\'code\'>Get()</span> methods.</p>\n\
<p>For example, the <span class=\'code\'>ParameterBlock.GetName()</span> method has a corresponding <span class=\'code\'>ParameterBlock.Name</span> property.</p>\n\
<p>In the <span class=\'code\'>demoApplyMaterial.py</span> example:</p>\n\
<div class=\'codeBlock\'><pre>m = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateDefaultStdMat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a419e1d850190ad66ccf4990a77bfcb6f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Factory.CreateDefaultStdMat</a>()\n\
m.Ambient = color\n\
m.Diffuse = color\n\
</pre></div><p>is equivalent to:</p>\n\
<div class=\'codeBlock\'><pre>m = <a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Factory.CreateDefaultStdMat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_factory.html#a419e1d850190ad66ccf4990a77bfcb6f&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MaxPlus.Factory.CreateDefaultStdMat</a>()\n\
m.SetAmbient(color)\n\
m.SetDiffuse(color)\n\
</pre></div><p>In the Python API Reference documentation, there are attribute descriptions along the lines of:</p>\n\
<p><span class=\'code\'>tuple Type = _swig_property(GetType)</span></p>\n\
<p>In this case, <span class=\'code\'>Type</span> is a property that you can query to obtain the <span class=\'code\'>Type</span> value, and its corresponding method is <span class=\'code\'>GetType()</span>.</p>\n\
<div class=\'section\'><a id=\"constants\"></a><h2 id=\"constants\">Constants</h2></div>\n\
<p>Constants are represented in the Python API along the lines of <span class=\'code\'>ColorSelection = _MaxPlus.Colors_ColorSelection</span> as a result of swig.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";