var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Performing inspection and obtaining the list of classes in the Python API</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Performing inspection and obtaining the list of classes in the Python API</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"performing-inspection-and-obtaining-the-list-of-classes-in-the-python-api\"></a></div>\n\
<p>The <span class=\'code\'>demoClassesInMaxPlus.py</span> example demonstrates how to obtain the list of classes in the 3ds Max Python API, and the corresponding number of API elements for each class.</p>\n\
<p>The <span class=\'code\'>inspect</span> module provides many useful functions to obtain information about modules, classes, methods, functions and so forth. In this example, the <span class=\'code\'>inspect.getmembers()</span> function is used.</p>\n\
<p>To use the inspect module, you must first:</p>\n\
<div class=\'codeBlock\'><pre>import inspect\n\
</pre></div><p>You can use the <span class=\'code\'>inspect.getmembers()</span> function with an optional predicate. If the optional predicate argument is used, then only members for which the predicate argument returns true are returned.</p>\n\
<p>Using this method, you can easily obtain a list of class members by setting your predicate argument to <span class=\'code\'>isclass</span>:</p>\n\
<div class=\'codeBlock\'><pre>classes = inspect.getmembers(MaxPlus, inspect.isclass)\n\
</pre></div><div class=\'section\'><a id=\"using-the-__dict__-property\"></a><h2 id=\"using-the-__dict__-property\">Using the __dict__ property</h2></div>\n\
<p>The <span class=\'code\'>\\__dict_\\_</span> property is a dictionary that represents the attributes of an object. Each item is a key:value pair where the first value is the name of the attribute and the second is the value of the attribute. In this example, we use the <span class=\'code\'>\\__dict_\\_</span> to obtain the name of the class and count its number of corresponding API elements:</p>\n\
<div class=\'codeBlock\'><pre>totalcnt = 0\n\
for c in classes:\n\
    name = str(c[0])    \n\
    membercnt = len(c[1].__dict__)\n\
    totalcnt += membercnt\n\
    api[name] = membercnt\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";