var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Python extension libraries</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Python extension libraries</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"python-extension-libraries\"></a></div>\n\
<p>Autodesk 3ds Max ships with a pre-built version of PySide 2.0, and is the preferred library for using QT with Python in 3ds Max (see <a href=\"#!/url=./developer/using_pyside.html\">Using PySide2</a>). You may install other CPython extension libraries as well. However, while every effort has been made to ensure that CPython extension libraries such as PyQt, SciPy, NumPy, PIL, and so forth work with Python in 3ds Max, Autodesk does not provide technical support for them.</p>\n\
<p>If you do want to use a CPython extension library such as PyQt, you must have the 64-bit binaries compiled using the same versions of Qt and Python that are used by 3ds Max 2018. These are Qt 5.6.2 and Python 2.7.6. Compiled extension libraries must then be placed at a location that can be found by Python. Python uses the list of directories in the <span class=\'code\'>sys.path</span> global variable to find the location of imported Python scripts and extension modules.</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> Python 2.7.6 is compiled with VC9.0, while 3ds Max 2018 is compiled with VC14.0. This means that you need to recompile CPython extension libraries for use with Python in 3ds Max with the more recent compiler.</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"installing-pip-for-package-management\"></a><h2 id=\"installing-pip-for-package-management\">Installing PIP for package management</h2></div>\n\
<p>Pip is a package management system for Python. It is useful for managing additional Python modules, including managing building modules from source (for example, NumPy). For libraries that contain pre-built binaries (such as zmq), you will need to obtain the source and re-build the binaries, replacing the ones installed by pip. By default, pip will try to use pre-built binaries. You can force pip to build from source with the --no-binary flag, and specifying a required version (see example below).</p>\n\
<p>Visual Studio 2015 (with VC14.0) must be installed to build libraries from source.</p>\n\
<p>To install pip:</p>\n\
<ol>\n\
<li>Obtain the get-pip.py script, for example from https://bootstrap.pypa.io/get-pip.py, and save it in <span class=\"filePath\" translate=\"no\">&lt;3ds Max Install&gt;\\scripts\\Python</span>.</li>\n\
<li>Open a command prompt in &lt;3ds Max Install&gt; and run: <span class=\'code\'>3dsmaxpy.exe scripts\\\\Python\\\\get-pip.py</span></li>\n\
<li>Once pip is installed, you can use it for package installation by running it directly from the <span class=\"filePath\" translate=\"no\">&lt;3ds Max Install&gt;\\Python\\scripts</span> directory. For example, to install NumPy, open a command prompt in <span class=\"filePath\" translate=\"no\">&lt;3ds Max Install&gt;\\Python\\scripts</span>, and run: <span class=\'code\'>pip install --no-cache-dir --no-binary numpy numpy==1.10.4</span>. This will download, compile and install NumPy.</li>\n\
</ol>\n\
<blockquote>\n\
<p><strong>Note:</strong> Use the <span class=\'code\'>--no-cache-dir</span> option if Python is installed on your computer.</p>\n\
</blockquote>\n\
<blockquote>\n\
<p><strong>Note:</strong> By default, 3dsmaxpy.exe handles the case where there is a space in the path of the 3ds Max python install. You can disable this feature by setting an environment variable, <span class=\'code\'>\\__disable_space_handling</span> to FALSE.</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";