var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>What&#39;s New in the 3ds Max 2018 Python API</title>\n\
   <meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>What&#39;s New in the 3ds Max 2018 Python API</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"whats-new-in-the-3ds-max-2018-python-api\"></a></div>\n\
<p>This release of 3ds Max introduces some changes and improvements to the Max Python API.</p>\n\
<div class=\'section\'><a id=\"python-version\"></a><h2 id=\"python-version\">Python version</h2></div>\n\
<p>The Python version used by 3ds Max has been upgraded to 2.7.12.</p>\n\
<div class=\'section\'><a id=\"pyside-version\"></a><h2 id=\"pyside-version\">PySide Version</h2></div>\n\
<p>The included PySide version is upgraded to PySide 2.0, to support upgraded Qt 5.6.2. PySide 2.0 moves widgets from <em>QtGui</em> into their own module, <em>QtWidgets</em>. Existing PySide-based scripts will need to add this import.</p>\n\
<p>This version of PySide includes the <span class=\'code\'>pyside2uic</span> module for loading Qt Designer .ui files.</p>\n\
<div class=\'section\'><a id=\"widget-docking\"></a><h2 id=\"widget-docking\">Widget Docking</h2></div>\n\
<p>The <span class=\'code\'>MakeQWidgetDockable</span> API has been removed, and is replaced by the standard PySide approach. <span class=\'code\'>QToolBar</span> and <span class=\'code\'>QDockWidget</span> can be docked to the main 3ds Max window. See the sample script <strong>[3dsmax]\\scripts\\\\Python\\demoPySideToolBarQWidget.py</strong>, which demonstrates the standard PySide approach.</p>\n\
<p><strong>Note:</strong> You need to run <strong>demoPySideToolBarQWidget.py</strong> from the <strong>Scripting &gt; Run Script</strong> menu, as it uses the <span class=\'code\'>__file__</span> global variable.</p>\n\
<div class=\'section\'><a id=\"ds-max-main-window-access\"></a><h2 id=\"ds-max-main-window-access\">3ds Max Main Window Access</h2></div>\n\
<p>The <span class=\'code\'>GetQMaxWindow()</span> function is replaced with <span class=\'code\'>GetQMaxMainWindow()</span>. <span class=\'code\'>GetQMaxWindowWinId()</span> is also removed, as the main window is now a native Qt window.</p>\n\
<div class=\'section\'><a id=\"createcuiframewindow\"></a><h2 id=\"createcuiframewindow\">CreateCUIFrameWindow</h2></div>\n\
<p>With the migration to Qt, you can no longer create a Windows CUI window using <span class=\'code\'>MaxPlus::CUIFrame.Create()</span>. Use <span class=\'code\'>PySide2</span> to create windows and dialogs.</p>\n\
<div class=\'section\'><a id=\"whats-new-in-3ds-max-2018.4-update\"></a><h2 id=\"whats-new-in-3ds-max-2018.4-update\">What&#39;s New in 3ds Max 2018.4 Update</h2></div>\n\
<div class=\'section\'><a id=\"by-reference-parameter-handling\"></a><h3 id=\"by-reference-parameter-handling\">By-Reference Parameter Handling</h3></div>\n\
<p>The pymxs module now supports functions that take by-reference parameters, with the new <span class=\'code\'>pymxs.mxsreference()</span> function. In previous versions, these parameters were not handled.</p>\n\
<p>For example:</p>\n\
<div class=\'codeBlock\'><pre class=\"prettyprint lang-py\">import MaxPlus\n\
rt = pymxs.runtime\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Core.EvalMAXScript\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a00c76297f347dd3d50c629827c7217a1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Core.EvalMAXScript</a>(&quot;mySphere = sphere radius:10&quot;)\n\
<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Core.EvalMAXScript\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a00c76297f347dd3d50c629827c7217a1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Core.EvalMAXScript</a>(&quot;myType = #reference&quot;)\n\
<a href=\"javascript:void(0)\" data-symbol=\"MaxPlus.Core.EvalMAXScript\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_max_plus_1_1_core.html#a00c76297f347dd3d50c629827c7217a1&quot;,&quot;title&quot;:&quot;MaxPlus Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MaxPlus.Core.EvalMAXScript</a>(&quot;myResultArray = Array()&quot;)\n\
\n\
offset1 = rt.Point3(50.0, 50.0, 10.0)\n\
myReturnedList = []\n\
rt.maxOps.cloneNodes(rt.mySphere,  offset=offset1, cloneType=rt.myType, newNodes=pymxs.mxsreference(myReturnedList))\n\
print &quot;python array: &quot;\n\
print myReturnedList\n\
\n\
offset2 = rt.Point3(-50.0, -50.0, 10.0)\n\
rt.maxOps.cloneNodes(rt.mySphere,  offset=offset2, cloneType=rt.myType, newNodes=pymxs.mxsreference(rt.myResultArray))\n\
print &quot;runtime array: &quot;\n\
print rt.myResultArray\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";